;; blue-steel/theme.jl
;; $Id$

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; The images and design of this theme are from Daniel Erat's
;; BlueSteel theme for Enlightenment

;; 16x20
(defvar blue-steel:menu-i (list (make-image "close_bg.png")
				(make-image "close_fg.png") nil
				(make-image "close_cl.png")))

;; 61x20
(defvar blue-steel:title-i (list (make-image "default_title_bg.png")
				 (make-image "default_title_fg.png")))

;; 85x20
(defvar blue-steel:toprighttrim-i (list (make-image "toprighttrim_bg.png")
					(make-image "toprighttrim_fg.png")))

;; 10x35
(defvar blue-steel:lefttrim-i (list (make-image "lefttrim_bg.png")
				    (make-image "lefttrim_fg.png")))

;; 35x16
(defvar blue-steel:top-i (list (make-image "default_top_bg.png")
			       (make-image "default_top_fg.png")))
(mapc #'(lambda (i)
	  (image-put i 'tiled t)) blue-steel:top-i)

;; 12x16
(defvar blue-steel:max-i (list (make-image "maximize_bg.png")
			       (make-image "maximize_fg.png") nil
			       (make-image "maximize_cl.png")))

;; 12x16
(defvar blue-steel:min-i (list (make-image "minimize_bg.png")
			       (make-image "minimize_fg.png") nil
			       (make-image "minimize_cl.png")))

;; 14x16
(defvar blue-steel:close-i (list (make-image "stick_bg.png")
				 (make-image "stick_fg.png") nil
				 (make-image "stick_cl.png")))

;; 6x81
(defvar blue-steel:right-i (list (make-image "right_bg.png")
				 (make-image "right_fg.png")))

;; 6x76
(defvar blue-steel:left-i (list (make-image "left_bg.png")
				(make-image "left_fg.png")))

;; 201x6
(defvar blue-steel:bottom-i (list (make-image "default_bottom_bg.png")
				  (make-image "default_bottom_fg.png")))

;; 45x10
(defvar blue-steel:bottomtrim-i (list (make-image "default_bottomtrim_bg.png")
				      (make-image "default_bottomtrim_fg.png")))

;; 10x35
(defvar blue-steel:righttrim-i (list (make-image "righttrim_bg.png")
				     (make-image "righttrim_fg.png")))

;; 11x6
(defvar blue-steel:bottomresize-i (list (make-image "bottomresize_bg.png")
					(make-image "bottomresize_fg.png")))

;; 213x6
(defvar blue-steel:trans-top-i (list (set-image-border
				      (make-image "verysmall_top_bg.png")
				      10 10 0 0)
				     (set-image-border
				      (make-image "verysmall_top_fg.png")
				      10 10 0 0)))
(defvar blue-steel:trans-bottom-i (list (set-image-border
					 (make-image "fixed_bottom_bg.png")
					 10 10 0 0)
					(set-image-border
					 (make-image "fixed_bottom_fg.png")
					 10 10 0 0)))

(defun blue-steel:title-width (w)
  (let
      ((w-width (car (window-dimensions w))))
    (max 0 (- (min (max (/ w-width 2) 100) w-width) 30))))

(defvar blue-steel:frame
  `((;; menu
     (background . ,blue-steel:menu-i)
     (left-edge . -10)
     (top-edge . -20)
     (class . menu-button))
    (;; left title
     (background . ,blue-steel:title-i)
     (left-edge . 6)
     (top-edge . -20)
     (width . blue-steel:title-width)
     (foreground . "white")
     (text . window-name)
     (y-justify . 3)
     (x-justify . center)
     (class . title))
    (;; middle title
     (background . ,blue-steel:toprighttrim-i)
     (left-edge . (lambda (w)
		    (+ 6 (blue-steel:title-width w))))
     (top-edge . -20)
     (class . title))
    (;; right title
     (background . ,blue-steel:top-i)
     (left-edge . (lambda (w)
		    (+ 6 (blue-steel:title-width w) 85)))
     (top-edge . -16)
     (right-edge . 32)
     (class . title))
    (;; minimize
     (background . ,blue-steel:min-i)
     (right-edge . 20)
     (top-edge . -16)
     (class . iconify-button))
    (;; maximize
     (background . ,blue-steel:max-i)
     (right-edge . 8)
     (top-edge . -16)
     (class . maximize-button))
    (;; close
     (background . ,blue-steel:close-i)
     (right-edge . -6)
     (top-edge . -16)
     (class . close-button))
    (;; topleft trim
     (background . ,blue-steel:lefttrim-i)
     (left-edge . -10)
     (top-edge . 0)
     (class . left-border))
    (;; left border
     (background . ,blue-steel:left-i)
     (left-edge . -6)
     (top-edge . 35)
     (bottom-edge . -6)
     (class . left-border))
    (;; bottom-left corner
     (background . ,blue-steel:bottomresize-i)
     (left-edge . -6)
     (bottom-edge . -6)
     (class . bottom-left-corner))
    (;; bottom
     (background . ,blue-steel:bottom-i)
     (left-edge . 5)
     (right-edge . 29)
     (bottom-edge . -6)
     (class . bottom-border))
    (;; bottom right trim
     (background . ,blue-steel:bottomtrim-i)
     (right-edge . -10)
     (bottom-edge . -10)
     (class . bottom-right-corner))
    (;; right bottom trim
     (background . ,blue-steel:righttrim-i)
     (right-edge . -10)
     (bottom-edge . -2)
     (class . bottom-right-corner))
    (;; right border
     (background . ,blue-steel:right-i)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 29)
     (class . right-border))))

(defvar blue-steel:shaped-frame
  `((;; menu
     (background . ,blue-steel:menu-i)
     (left-edge . -10)
     (top-edge . -20)
     (class . menu-button))
    (;; left title
     (background . ,blue-steel:title-i)
     (left-edge . 6)
     (top-edge . -20)
     (width . blue-steel:title-width)
     (foreground . "white")
     (text . window-name)
     (y-justify . 3)
     (x-justify . center)
     (class . title))
    (;; middle title
     (background . ,blue-steel:toprighttrim-i)
     (left-edge . (lambda (w)
		    (+ 6 (blue-steel:title-width w))))
     (top-edge . -20)
     (class . title))
    (;; right title
     (background . ,blue-steel:top-i)
     (left-edge . (lambda (w)
		    (+ 6 (blue-steel:title-width w) 85)))
     (top-edge . -16)
     (right-edge . 32)
     (class . title))
    (;; minimize
     (background . ,blue-steel:min-i)
     (right-edge . 20)
     (top-edge . -16)
     (class . iconify-button))
    (;; maximize
     (background . ,blue-steel:max-i)
     (right-edge . 8)
     (top-edge . -16)
     (class . maximize-button))
    (;; close
     (background . ,blue-steel:close-i)
     (right-edge . -6)
     (top-edge . -16)
     (class . close-button))))

(defvar blue-steel:transient-frame
  `((;; top
     (background . ,blue-steel:trans-top-i)
     (left-edge . -6)
     (right-edge . -6)
     (top-edge . -6)
     (class . title))
    (;; right
     (background . ,blue-steel:right-i)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))
    (;; left
     (background . ,blue-steel:left-i)
     (left-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . left-border))
    (;; bottom
     (background . ,blue-steel:trans-bottom-i)
     (left-edge . -6)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-border))))

(defvar blue-steel:shaped-transient-frame
  `((;; top
     (background . ,blue-steel:trans-top-i)
     (left-edge . -6)
     (right-edge . -6)
     (top-edge . -6)
     (class . title))))

(defun blue-steel:frame-style (w type)
  (cond ((eq type 'shaped)
	 'blue-steel:shaped-frame)
	((eq type 'transient)
	 'blue-steel:transient-frame)
	((eq type 'shaped-transient)
	 'blue-steel:shaped-transient-frame)
	((eq type 'unframed)
	 'nil-frame)
	(t
	 'blue-steel:frame)))

(add-frame-style 'blue-steel 'blue-steel:frame-style)
